apiVersion: apps/v1
kind: Deployment
metadata:
  name: cvcloud-authenticator
  namespace: authenticator
spec:
  replicas: 2
  template:
    spec:
      serviceAccountName: authenticator
      securityContext:
        runAsUser: 65532
      affinity:
        podAntiAffinity:
          requiredDuringSchedulingIgnoredDuringExecution:
            - labelSelector:
                matchExpressions:
                  - key: app.kubernetes.io/name
                    operator: In
                    values:
                      - authenticator
              topologyKey: kubernetes.io/hostname
      initContainers:
        - name: config-creator
          command:
            - /authenticator
          args:
            - create
          image: authenticator
          imagePullPolicy: Always
          securityContext:
            allowPrivilegeEscalation: false
          resources:
            limits:
              cpu: 300m
              memory: 300Mi
            requests:
              cpu: 150m
              memory: 150Mi
          volumeMounts:
            - mountPath: /var/lib/kubeconfig
              name: kubeconfig
      containers:
        - name: authenticator
          command: ["/authenticator"]
          args: ["start"]
          image: authenticator
          imagePullPolicy: Always
          livenessProbe:
            httpGet:
              path: /healthz
              port: 8888
            initialDelaySeconds: 15
            periodSeconds: 20
          readinessProbe:
            httpGet:
              path: /readyz
              port: 8888
            initialDelaySeconds: 5
            periodSeconds: 10
          securityContext:
            allowPrivilegeEscalation: false
          ports:
            - containerPort: 8888
          resources:
            limits:
              cpu: 300m
              memory: 300Mi
            requests:
              cpu: 150m
              memory: 150Mi
          volumeMounts:
            - mountPath: /var/lib/kubeconfig
              name: kubeconfig
      volumes:
        - name: kubeconfig
          emptyDir: {}
      terminationGracePeriodSeconds: 10
